%{!?python2_sitearch: %define python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%define with_ocaml 0
%define build_ocaml 0
%define with_xsm 0
%define build_xsm 0
# cross compile 64-bit hypervisor on ix86 unless rpmbuild was run
#	with --without crosshyp
%define build_crosshyp %{?_without_crosshyp: 0} %{?!_without_crosshyp: 1}
%ifnarch %{ix86}
%define build_crosshyp 0
%define build_hyp 1
%else
%if %build_crosshyp
%define build_hyp 1
%else
%define build_hyp 0
# no point in trying to build xsm on ix86 without a hypervisor
%define build_xsm 0
%endif
%endif
# build an efi boot image (where supported) unless rpmbuild was run with
# --without efi
%define build_efi %{?_without_efi: 0} %{?!_without_efi: 1}
# xen only supports efi boot images on x86_64
%ifnarch x86_64
%define build_efi 0
%endif
%define with_python2 1
%define with_python3 1

# Hypervisor ABI
%define hv_abi  4.8

Summary: Xen is a virtual machine monitor
Name:    xen
Version: 4.8.4
Release: 6%{?dist}
Epoch:   2001
Group:   Development/Libraries
License: GPLv2+ and LGPLv2+ and BSD
URL:     http://xen.org/
Source0: xen-%{version}.tar.gz
Source2: %{name}.logrotate
Source3: config
# used by stubdoms
Source10: lwip-1.3.0.tar.gz
Source11: newlib-1.16.0.tar.gz
Source12: zlib-1.2.3.tar.gz
Source13: pciutils-2.2.9.tar.bz2
Source14: grub-0.97.tar.gz
Source15: gmp-4.3.2.tar.bz2
Source16: polarssl-1.1.4-gpl.tgz
Source18: tpm_emulator-0.7.4.tar.gz
Source32: xen.modules-load.conf

# Qubes components for stubdom
Source33: gui-agent-xen-hvm-stubdom-5f57a59.tar.gz
Source34: core-vchan-xen-42d07fb.tar.gz
Source35: stubdom-dhcp-088ded9.tar.gz
Source36: gui-common-c611481.tar.gz

# Out-of-tree patches.
#
# Use the following patch numbers:
# 100+:  Fedora
# 200+:  EFI workarounds
# 300+:  Backports
# 400+:  PVH backports
# 500+:  Security fixes
# 600+:  Upstreamable patches
# 700+:  GCC7 fixes
# 800+:  vchan for stubdom:
# 900+:  Qubes specific patches
# 1000+: python3
# 1100+: Support for Linux based stubdom

# Fedora
Patch101: patch-xen.use.fedora.ipxe.patch
Patch102: patch-xen.fedora.efi.build.patch
Patch103: patch-xen.gcc5.fix.patch
Patch104: patch-xen.vwprintw.fix.patch

# EFI workarounds

Patch201: patch-0001-EFI-early-Add-noexit-to-inhibit-calling-ExitBootServices.patch
Patch202: patch-0002-efi-Ensure-incorrectly-typed-runtime-services-get-ma.patch
Patch203: patch-0001-Add-xen.cfg-options-for-mapbs-and-noexitboot.patch

# Backports
Patch301: patch-0001-libxl-add-more-cpuid-flags-handling.patch
Patch302: patch-libxc-panic-when-trying-to-create-a-PVH-guest-withou.patch
Patch303: patch-b4f98dc0-tools-fix-typo-in-tools-Rules.mk.patch
Patch304: patch-448c03b3-tools-xenstore-try-to-get-minimum-thread-stack-size-.patch
Patch305: patch-c9bd8a73-tools-xenstore-add-libdl-dependency-to-libxenstore.patch
Patch306: patch-1a373194-tools-xenstore-fix-linking-libxenstore-with-ldl.patch


# PVH backports
Patch401: patch-88e43f9a-acpi-make-pmtimer-optional-in-FADT.patch
Patch402: patch-b5419306-acpi-power-and-sleep-ACPI-buttons-are-not-emulated-f.patch
Patch403: patch-aff79e7a-acpi-PVH-guests-need-_E02-method.patch
Patch404: patch-3b7a1b85-libacpi-add-_FADT_-to-the-FADT-boot-flags-definition.patch
Patch405: patch-3031b10e-libacpi-set-FADT-boot-flag-to-notify-lack-of-VGA-for.patch
Patch406: patch-4604e0b5-libacpi-don-t-announce-a-8042-controller-in-the-FADT.patch
Patch407: patch-c281cd3b-libacpi-update-FADT-layout-to-support-version-5.patch
Patch408: patch-9f7fea37-libacpi-announce-that-PVHv2-has-no-CMOS-RTC-in-FADT.patch
Patch409: patch-9a70679d-firmware-rombios-fix-after-update-to-libacpi.patch
Patch410: patch-666a1ded-x86-pmtimer-move-ACPI-registers-from-PMTState-to-hvm.patch
Patch411: patch-4dbaa654-libxl-Update-xenstore-on-VCPU-hotplug-for-all-guest-.patch
Patch412: patch-ea9e7fd9-libxl-add-is_default-checkers-for-string-and-timer_m.patch
Patch413: patch-5eee1677-xl-parsing-code-movement.patch
Patch414: patch-84238f2f-libxl-pvh-Add-accessor-macros-for-domain-type-and-ve.patch
Patch415: patch-f41fd2fe-libxl-pvh-Use-accessor-macros-internally.patch
Patch416: patch-ce297088-xl-pvh-Use-accessor-macros.patch
Patch417: patch-23adea59-MAYBE-FIX-libxl-xl-use-the-new-location-of-domain_bu.patch
Patch418: patch-3c717179-xl-introduce-a-domain-type-option.patch
Patch419: patch-46985bb4-xl-introduce-a-firmware-option.patch
Patch420: patch-ded8f147-libxl-don-t-segfault-when-creating-domain-with-inval.patch
Patch421: patch-e8fbb1fa-libxl-introduce-a-PVH-guest-type.patch
Patch422: patch-9cbd5666-libxl-allow-PVH-guests-to-use-a-bootloader.patch
Patch423: patch-556bb771-libxl-set-PVH-guests-to-use-the-PV-console.patch
Patch424: patch-b2a9d4ab-libxl-add-PVH-support-to-domain-creation.patch
Patch425: patch-95fa85ce-libxl-remove-device-model-none-support-from-disk-rel.patch
Patch426: patch-6f766694-libxl-set-device-model-for-PVH-guests.patch
Patch427: patch-35d9650f-libxl-add-PVH-support-to-domain-building.patch
Patch428: patch-040057b2-libxl-add-PVH-support-to-domain-save-suspend.patch
Patch429: patch-dfcd6be8-libxl-add-PVH-support-to-vpcu-hotplug-domain-destruc.patch
Patch430: patch-1716a61c-libxl-add-PVH-support-to-memory-functions.patch
Patch431: patch-98733e66-libxl-PVH-guests-use-PV-nics.patch
Patch432: patch-f3792730-libxl-remove-device-model-none-support-from-stream-f.patch
Patch433: patch-1c0771fc-libxl-add-PVH-support-to-USB.patch
Patch434: patch-b6a0564b-libxl-add-PVH-support-to-x86-functions.patch
Patch435: patch-0f1d3c78-xl-add-PVH-as-a-guest-type.patch
Patch436: patch-6d1a9bcb-libxl-remove-device-model-none-from-IDL.patch
Patch437: patch-60efd677-xl-Don-t-warn-on-using-deprecated-mode-selection.patch

Patch438: patch-x86-check-feature-flags-after-resume.patch

# Security fixes

# Update to staging-4.8 for XSA-273
Patch501: patch-3686d096-cmdline-fix-parse_boolean-for-NULL-incoming-end-poin.patch
Patch502: patch-de172b0f-xen-Port-the-array_index_nospec-infrastructure-from-.patch
Patch503: patch-f5ef10dd-x86-correctly-set-nonlazy_xstate_used-when-loading-f.patch
Patch504: patch-f3b0cdb4-x86-spec-ctrl-command-line-handling-adjustments.patch
Patch505: patch-23975f51-xen-oprofile-nmi_int.c-Drop-unwanted-sexual-referenc.patch
Patch506: patch-96bf2dbc-allow-cpu_down-to-be-called-earlier.patch
Patch507: patch-08eda978-cpupools-fix-state-when-downing-a-CPU-failed.patch
Patch508: patch-f6a31ed4-x86-AMD-distinguish-compute-units-from-hyper-threads.patch
Patch509: patch-37a1b4aa-x86-distinguish-CPU-offlining-from-CPU-removal.patch
Patch510: patch-6dc0bc58-x86-possibly-bring-up-all-CPUs-even-if-not-all-are-s.patch
Patch511: patch-f049cd67-x86-command-line-option-to-avoid-use-of-secondary-hy.patch
Patch512: patch-5566272d-x86-vmx-Don-t-clobber-dr6-while-debugging-state-is-l.patch
Patch513: patch-e343ee80-x86-xstate-Use-a-guests-CPUID-policy-rather-than-all.patch
Patch514: patch-c117d09f-x86-xstate-Make-errors-in-xstate-calculations-more-o.patch
Patch515: patch-b149b06b-x86-hvm-Disallow-unknown-MSR_EFER-bits.patch
Patch516: patch-aa450153-x86-spec-ctrl-Fix-the-parsing-of-xpti-on-fixed-Intel.patch
Patch517: patch-d8389572-x86-spec-ctrl-Yet-more-fixes-for-xpti-parsing.patch
Patch518: patch-790ed152-x86-vmx-Fix-handing-of-MSR_DEBUGCTL-on-VMExit.patch
Patch519: patch-15508b33-x86-vmx-Defer-vmx_vmcs_exit-as-long-as-possible-in-c.patch
Patch520: patch-d96893fe-x86-vmx-API-improvements-for-MSR-load-save-infrastru.patch
Patch521: patch-df5bbf7a-x86-vmx-Internal-cleanup-for-MSR-load-save-infrastru.patch
Patch522: patch-ee7bceaf-x86-vmx-Factor-locate_msr_entry-out-of-vmx_find_msr-.patch
Patch523: patch-47fbc6e0-x86-vmx-Support-remote-access-to-the-MSR-lists.patch
Patch524: patch-b2894035-x86-vmx-Improvements-to-LBR-MSR-handling.patch
Patch525: patch-b81b74aa-x86-vmx-Pass-an-MSR-value-into-vmx_msr_add.patch
Patch526: patch-3478439f-x86-vmx-Support-load-only-guest-MSR-list-entries.patch
Patch527: patch-c00fabcd-VMX-fix-vmx_-find-del-_msr-build.patch
Patch528: patch-e3d0ce38-common-gnttab-Introduce-command-line-feature-control.patch
Patch529: patch-04061641-ARM-disable-grant-table-v2.patch
Patch530: patch-ed6fcdb9-x86-vtx-Fix-the-checking-for-unknown-invalid-MSR_DEB.patch
Patch531: patch-712082da-tools-oxenstored-Make-evaluation-order-explicit.patch
Patch532: patch-28fc483f-x86-spec-ctrl-Calculate-safe-PTE-addresses-for-L1TF-.patch
Patch533: patch-fe788294-x86-spec-ctrl-Introduce-an-option-to-control-L1TF-mi.patch
Patch534: patch-e819108a-x86-shadow-Infrastructure-to-force-a-PV-guest-into-s.patch
Patch535: patch-7849d13d-x86-mm-Plumbing-to-allow-any-PTE-update-to-fail-with.patch
Patch536: patch-9e7d5e26-x86-pv-Force-a-guest-into-shadow-mode-when-it-writes.patch
Patch537: patch-5464d5f0-x86-spec-ctrl-CPUID-MSR-definitions-for-L1D_FLUSH.patch
Patch538: patch-1f56fba4-x86-msr-Virtualise-MSR_FLUSH_CMD-for-guests.patch
Patch539: patch-1c6c2def-x86-spec-ctrl-Introduce-an-option-to-control-L1D_FLU.patch
Patch540: patch-565de91a-x86-Make-spec-ctrl-no-a-global-disable-of-all-mitiga.patch
Patch541: patch-d95b5bb3-xl.conf-Add-global-affinity-masks.patch

# Upstreamable patches
Patch601: patch-xen-libxl-error-write-perm.patch
Patch602: patch-xen-xl-create-quiet.patch
#Patch603: patch-libxl-make-nic-bridge-parameter-optional-do-not-fill.patch
Patch604: patch-libxl-Revert-libxl-Remove-redundant-setting-of-phyical-dev.patch
Patch605: patch-libxl-allow-PHY-backend-for-files-allocate-loop-devi.patch
Patch606: patch-libxl-do-not-call-default-block-script.patch
Patch607: patch-libxl-do-not-for-backend-on-PCI-remove-when-backend-.patch
Patch608: patch-libxl-fix-libxl_device_-_remove-with-driver-domain-s.patch
Patch609: patch-libxl-suspend.patch
Patch610: patch-stubdom-gmp-compile-fix.patch
Patch611: patch-0001-libxl-attach-xen-pciback-only-to-PV-domains.patch
Patch612: patch-0002-libxl-attach-PCI-device-to-qemu-only-after-setting-p.patch
Patch613: patch-0003-libxl-don-t-try-to-manipulate-json-config-for-stubdo.patch
Patch614: patch-0001-libxl-do-not-fail-device-removal-if-backend-domain-i.patch
Patch615: patch-hvmpt01-minios-exprom-size.patch
Patch616: patch-hvmpt02-disable-msix-caps.patch
Patch617: patch-hvmpt03-passthrough-log.patch
Patch618: patch-hvmpt04-minios-nomask-bar-addrs.patch
Patch619: patch-hvmpt05-hide-pio-bars.patch
Patch620: patch-hvmpt06-fix-msix.patch
Patch621: patch-libxc-fix-xc_gntshr_munmap-semantic.patch
Patch622: patch-minios-ignore-close-0.patch
Patch623: patch-libvchan-Fix-cleanup-when-xc_gntshr_open-failed.patch
Patch624: patch-qemu-docs-utf8.patch
Patch625: patch-minios-remove-net-device-instead-of-preparing-for-re.patch
Patch626: patch-xenconsole-sanitize-ESC-in-log.patch
Patch627: patch-qemu-keyboard-leds.patch

# GCC7 fixes
Patch701: patch-0001-tools-include-sys-sysmacros.h-on-Linux.patch
Patch702: patch-tools-misc-xenlockprof-fix-possible-format-string-overflow.patch
Patch703: patch-v2-tools-fix-several-format-truncation-warnings-with-GCC-7.patch
Patch704: patch-stubdom-fix-vtpm-compilation-on-GCC-7.patch
Patch705: patch-vtpmmgr-make-inline-functions-static.patch
Patch706: patch-mini-os-link-to-libgcc.a-to-fix-build-with-gcc7.patch
# GCC8 fixes
Patch707: patch-0001-tools-libxc-fix-strncpy-size.patch
Patch708: patch-tools-misc-fix-hypothetical-buffer-overflow-in-xen-l.patch
Patch709: patch-tools-blktap2-fix-hypothetical-buffer-overflow.patch
Patch710: patch-tools-blktap2-fix-possible-0-truncation.patch
Patch711: patch-memfd-fix-configure-test.patch
Patch712: patch-tools-xenpmd-fix-possible-0-truncation.patch
Patch713: patch-tools-gdbsx-fix-Wstringop-truncation-warning.patch
Patch714: patch-tools-kdd-mute-spurious-gcc-warning.patch
Patch715: patch-stubdom-apply-gcc-8-fix-for-tpm-emulator.patch

# vchan for stubdom:
Patch801: patch-0100-minios-enhance-xenstore-available-for-stubdoms.patch
Patch802: patch-0101-libvchan-create-xenstore-entries-in-one-transaction.patch
Patch803: patch-0102-libvchan-remove-unnecessary-includes.patch
Patch804: patch-0103-minios-implement-gntalloc-interface.patch
Patch805: patch-0104-libxc-implement-gntshr-for-minios.patch
Patch806: patch-0105-stubdom-make-libvchan-available-in-stubdom.patch

# Qubes specific patches
Patch901: patch-stubdom-vbd-non-dom0-backend.patch
Patch902: patch-xen-no-downloads.patch
Patch903: patch-xen-hotplug-external-store.patch
Patch904: patch-xen-stubdom-qubes-gui.patch
Patch905: patch-stubdom-lwip-fix-for-dhcp.patch
Patch906: patch-xen-libxl-qubes-minimal-stubdom.patch
Patch907: patch-xen-disable-dom0-qemu.patch
Patch908: patch-libxl-disable-forced-vkb-for-HVM.patch
Patch909: patch-xenconsoled-enable-logging.patch
Patch910: patch-vm-0001-hotplug-do-not-attempt-to-remove-containing-xenstore.patch
Patch911: patch-xen-hotplug-qubesdb-update.patch
Patch912: patch-tools-hotplug-drop-perl-usage-in-locking-mechanism.patch

# python3
Patch1001: patch-0001-python-check-return-value-of-PyErr_NewException.patch
Patch1002: patch-0002-python-drop-tp_getattr-implementation.patch
Patch1003: patch-0003-python-use-Py_TYPE-instead-of-looking-directly-into-.patch
Patch1004: patch-0004-python-initialize-specific-fields-of-PyTypeObject.patch
Patch1005: patch-0005-python-use-PyBytes-PyUnicode-instead-of-PyString.patch
Patch1006: patch-0006-python-use-PyLong_-for-constructing-int-type-in-Pyth.patch
Patch1007: patch-0007-python-adjust-module-initalization-for-Python3.patch
Patch1008: patch-0008-python-handle-long-type-in-scripts.patch

# Support for Linux based stubdom
Patch1101: patch-stubdom-linux-0004.patch
Patch1102: patch-stubdom-linux-0005.patch
Patch1103: patch-stubdom-linux-0006.patch
Patch1104: patch-stubdom-linux-libxl-soname.patch
Patch1105: patch-stubdom-linux-pci-add-del.patch
Patch1106: patch-stubdom-linux-config-qubes-gui.patch
Patch1107: patch-stubdom-linux-fix-need-memory.patch
Patch1108: patch-stubdom-linux-config-stubdom-mem.patch
Patch1109: patch-stubdom-linux-libxl-suspend.patch
Patch1110: patch-stubdom-linux-libxl-silence-dm_check_start.patch
Patch1111: patch-stubdom-linux-libxl-do-not-force-qdisk-backend-for-cdrom.patch
Patch1112: patch-stubdom-linux-libxl-don-t-try-to-resolve-local-disk-path-with-stub.patch
Patch1113: patch-stubdom-allow-msi-irq.patch
Patch1114: patch-stubdom-allow-msi-enable.patch
Patch1115: patch-stubdom-linux-cmdline.patch
Patch1116: patch-xenstore-client-raw.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: transfig libidn-devel zlib-devel texi2html SDL-devel curl-devel
BuildRequires: libX11-devel ghostscript texlive-latex
%if %with_python2
BuildRequires: python2-devel
%endif
%if %with_python3
BuildRequires: python%{python3_pkgversion}-devel
%endif
%if 0%{?fedora} >= 18
BuildRequires: texlive-times texlive-courier texlive-helvetic texlive-ntgclass
%endif
BuildRequires: ncurses-devel gtk2-devel libaio-devel nettle-devel
# for the docs
BuildRequires: perl perl(Pod::Man) perl(Pod::Text) texinfo graphviz
# so that the makefile knows to install udev rules
BuildRequires: udev
%ifarch %{ix86} x86_64
# so that x86_64 builds pick up glibc32 correctly
BuildRequires: /usr/include/gnu/stubs-32.h
# for the VMX "bios"
BuildRequires: dev86
%endif
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: gettext
BuildRequires: gnutls-devel
BuildRequires: openssl-devel
# For ioemu PCI passthrough
BuildRequires: pciutils-devel
# Several tools now use uuid
BuildRequires: libuuid-devel
# iasl needed to build hvmloader
BuildRequires: iasl
# build using Fedora's ipxe package for roms
BuildRequires: ipxe-roms-qemu
# modern compressed kernels
BuildRequires: bzip2-devel xz-devel
# libfsimage
BuildRequires: e2fsprogs-devel
# tools now require yajl
BuildRequires: yajl-devel
# stubdom build requires cmake
BuildRequires: cmake
%if %with_xsm
# xsm policy file needs needs checkpolicy and m4
BuildRequires: checkpolicy m4
%endif
%if %build_crosshyp
# cross compiler for building 64-bit hypervisor on ix86
BuildRequires: gcc-x86_64-linux-gnu
%endif
# gcc with BTI mitigation, for dom0 build
%if 0%{?fedora} == 25
BuildRequires: gcc >= 6.4.1-1.qubes1
%endif
Requires: bridge-utils
%if 0%{?fedora} >= 29
Requires: python2-lxml
%else
Requires: python-lxml
%endif
Requires: udev >= 059
Requires: xen-runtime = %{version}-%{release}
# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Requires: chkconfig
ExclusiveArch: %{ix86} x86_64
#ExclusiveArch: %%{ix86} x86_64 ia64 noarch
%if %with_ocaml
BuildRequires: ocaml, ocaml-findlib
%endif
# efi image needs an ld that has -mi386pep option
%if %build_efi
BuildRequires: mingw64-binutils
%endif
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd
BuildRequires: systemd-devel
# BIOS for HVMs
%if 0%{?rhel} >= 7
BuildRequires: OVMF
%else
BuildRequires: edk2-ovmf
%endif

%description
This package contains the XenD daemon and xm command line
tools, needed to manage virtual machines running under the
Xen hypervisor

%if %with_python2
%package -n python2-%{name}
Summary: Python2 bindings for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: python2
%{?python_provide:%python_provide python2-%{name}}

%description -n python2-%{name}
This package contains Python2 bindings to Xen tools. Especially xen.lowlevel.xs
and xen.lowlevel.xc modules.

%endif

%if %with_python3
%package -n python%{python3_pkgversion}-%{name}
Summary: Python3 bindings for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: python3
%{?python_provide:%python_provide python%{python3_pkgversion}-%{name}}

%description -n python%{python3_pkgversion}-%{name}
This package contains Python3 bindings to Xen tools. Especially xen.lowlevel.xs
and xen.lowlevel.xc modules.
%endif

%package libs
Summary: Libraries for Xen tools
Group: Development/Libraries
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig
Requires: xen-licenses
Provides: xen-libs = %{version}-%{release}
Obsoletes: xen-qubes-vm-libs < %{epoch}:%{version}-%{release}
# ifup/ifdown arguments dropped
Conflicts: xen-hvm-stubdom-linux < 1.0.10
# pvh definition syntax change
Conflicts: libvirt-daemon-driver-libxl < 3.3.0-7

%description libs
This package contains the libraries needed to run applications
which manage Xen virtual machines.


%package runtime
Summary: Core Xen runtime environment
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
# Ensure we at least have a suitable kernel installed, though we can't
# force user to actually boot it.
Requires: xen-hypervisor-abi = %{hv_abi}
Provides: xen-runtime = %{version}-%{release}

%description runtime
This package contains the runtime programs and daemons which
form the core Xen userspace environment.


%package hypervisor
Summary: Libraries for Xen tools
Group: Development/Libraries
Provides: xen-hypervisor-abi = %{hv_abi}
Requires: xen-licenses

%description hypervisor
This package contains the Xen hypervisor


%package doc
Summary: Xen documentation
Group: Documentation
#BuildArch: noarch
Requires: xen-licenses

%description doc
This package contains the Xen documentation.


%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-libs = %{version}-%{release}
Requires: libuuid-devel
Provides: xen-devel = %{version}-%{release}
Obsoletes: xen-qubes-vm-devel

%description devel
This package contains what's needed to develop applications
which manage Xen virtual machines.


%package licenses
Summary: License files from Xen source
Group: Documentation

%description licenses
This package contains the license files from the source used
to build the xen packages.


%if %build_ocaml
%package ocaml
Summary: Ocaml libraries for Xen tools
Group: Development/Libraries
Requires: ocaml-runtime, xen-libs = %{version}-%{release}

%description ocaml
This package contains libraries for ocaml tools to manage Xen
virtual machines.


%package ocaml-devel
Summary: Ocaml development libraries for Xen tools
Group: Development/Libraries
Requires: xen-ocaml = %{version}-%{release}

%description ocaml-devel
This package contains libraries for developing ocaml tools to
manage Xen virtual machines.
%endif

%package hvm
Summary: Loader and device-model for HVM
Requires: xen-libs = %{version}-%{release}
Requires: xen-runtime = %{version}-%{release}

%description hvm
This package contains files for HVM domains, especially stubdomain with device model.

%package qemu-tools
Summary: Qemu disk tools bundled with Xen
Requires: xen-hvm = %{version}-%{release}
Provides: qemu-img
Conflicts: qemu-img

%description qemu-tools
This package contains symlinks to qemu tools (qemu-img, qemu-nbd, qemu-io)
budled with Xen, making them available for general use.

%package qubes-vm
Summary: Xen files required in Qubes VM
Requires: xen-libs = %{epoch}:%{version}-%{release}
Conflicts: xen
Provides: xen-qubes-vm-essentials = %{epoch}:%{version}-%{release}

%description qubes-vm
Just a few xenstore-* tools and Xen hotplug scripts needed by Qubes VMs

%prep
%autosetup -p1

# Fix for glibc 2.7
#FIXME sed 's:LIBS+=-lutil:LIBS+=-lutil -lrt:' -i tools/ioemu-qemu-xen/Makefile.target

# stubdom sources
cp -v %{SOURCE10} %{SOURCE11} %{SOURCE12} %{SOURCE13} %{SOURCE14} stubdom
cp -v %{SOURCE15} %{SOURCE16} %{SOURCE18} stubdom

# qubes specific parts of stubdom
tar xf %{SOURCE33}
mkdir tools/qubes-gui/
cp -a gui-agent-xen-hvm-stubdom/* tools/qubes-gui/

tar xf %{SOURCE36}
cp -a gui-common/include/qubes-gui*.h tools/qubes-gui/include/
make -C tools/qubes-gui clean

tar xf %{SOURCE34}
cp -a core-vchan-xen/vchan tools/
make -C tools/vchan -f Makefile.stubdom clean
sed -e 's/ioemu-qemu-xen/qemu-xen-traditional/g' tools/qubes-gui/gui-agent-qemu/qemu-glue.patch | patch -p1

tar xf %{SOURCE35}
cp -a stubdom-dhcp/* tools/qemu-xen-traditional/
patch -d tools/qemu-xen-traditional -p4 < stubdom-dhcp/lwip-dhcp-qemu-glue.patch


%build
%if !%build_ocaml
%define ocaml_flags OCAML_TOOLS=n
%endif
%if %build_efi
%define efi_flags LD_EFI=/usr/x86_64-w64-mingw32/bin/ld EFI_VENDOR=qubes
mkdir -p dist/install/boot/efi/efi/qubes
%endif
export XEN_VENDORVERSION="-%{release}"
export CFLAGS_EXTRA="$RPM_OPT_FLAGS"
export PATH="/usr/bin:$PATH"
export PYTHON=%{__python2}
export KCONFIG_CONFIG=%{SOURCE3}
cp -f %{SOURCE3} xen/.config
export XEN_CONFIG_EXPERT=y
autoreconf
make %{?_smp_mflags} %{?efi_flags} prefix=/usr dist-xen
# setting libexecdir to real libexec is broken in the configure script (it is
# overrided by /usr/lib)
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --libexecdir=/usr/lib \
    --with-system-seabios=/usr/lib/xen/boot/seabios-256k.bin \
    --with-system-ovmf=/usr/lib/xen/boot/ovmf.bin \
    --enable-vtpm-stubdom \
    --enable-vtpmmgr-stubdom \
    --with-extra-qemuu-configure-args="--disable-spice"
make %{?_smp_mflags} %{?ocaml_flags} prefix=/usr dist-tools
make                 prefix=/usr dist-docs
unset CFLAGS
make %{?ocaml_flags} dist-stubdom

%if %with_python2
make PYTHON=%{__python2} -C tools/python
%endif
%if %with_python3
make PYTHON=%{__python3} -C tools/python
%endif

%install
rm -rf %{buildroot}
%if %build_ocaml
mkdir -p %{buildroot}%{_libdir}/ocaml/stublibs
%endif
%if %build_efi
mkdir -p %{buildroot}/boot/efi/efi/qubes
%endif
export PYTHON=%{__python2}
make DESTDIR=%{buildroot} %{?efi_flags}  prefix=/usr install-xen
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-tools
make DESTDIR=%{buildroot} prefix=/usr install-docs
make DESTDIR=%{buildroot} %{?ocaml_flags} prefix=/usr install-stubdom
%if %build_efi
mv %{buildroot}/boot/efi/efi %{buildroot}/boot/efi/EFI
%endif
%if %build_xsm
# policy file should be in /boot/flask
mkdir %{buildroot}/boot/flask
mv %{buildroot}/boot/xenpolicy* %{buildroot}/boot/flask
%else
rm -f %{buildroot}/boot/xenpolicy*
rm -f %{buildroot}/usr/sbin/flask-*
%endif

%if %with_python2
make PYTHON=%{__python2} DESTDIR=%{buildroot} prefix=/usr -C tools/python install
%endif
%if %with_python3
make PYTHON=%{__python3} DESTDIR=%{buildroot} prefix=/usr -C tools/python install
%endif

# qemu symlinks
mkdir -p %{buildroot}/usr/bin
ln -s ../lib/%{name}/bin/qemu-img %{buildroot}/usr/bin/
ln -s ../lib/%{name}/bin/qemu-io  %{buildroot}/usr/bin/
ln -s ../lib/%{name}/bin/qemu-nbd %{buildroot}/usr/bin/

# "build" combined OVMF image based on system package
%if 0%{?rhel} >=7
cat /usr/share/OVMF/OVMF_{VARS,CODE.secboot}.fd > %{buildroot}/usr/lib/xen/boot/ovmf.bin
%else
cat /usr/share/edk2/ovmf/OVMF_{VARS,CODE}.fd > %{buildroot}/usr/lib/xen/boot/ovmf.bin
%endif

############ debug packaging: list files ############

find %{buildroot} -print | xargs ls -ld | sed -e 's|.*%{buildroot}||' > f1.list

############ kill unwanted stuff ############

# stubdom: newlib
rm -rf %{buildroot}/usr/*-xen-elf

# hypervisor symlinks
rm -rf %{buildroot}/boot/xen-4.7.gz
rm -rf %{buildroot}/boot/xen-4.gz
rm -rf %{buildroot}/boot/xen.gz
%if !%build_hyp
rm -rf %{buildroot}/boot
%endif

# silly doc dir fun
rm -rf %{buildroot}%{_datadir}/doc/xen
rm -rf %{buildroot}%{_datadir}/doc/qemu

# Pointless helper
rm -f %{buildroot}%{_sbindir}/xen-python-path

# qemu stuff (unused or available from upstream)
rm -rf %{buildroot}/usr/share/xen/man
for file in bios.bin openbios-sparc32 openbios-sparc64 ppc_rom.bin \
         pxe-e1000.bin pxe-ne2k_pci.bin pxe-pcnet.bin pxe-rtl8139.bin \
         vgabios.bin vgabios-cirrus.bin video.x openbios-ppc bamboo.dtb
do
	rm -f %{buildroot}/%{_datadir}/xen/qemu/$file
done
rm -f %{buildroot}/usr/libexec/qemu-bridge-helper

# README's not intended for end users
rm -f %{buildroot}/%{_sysconfdir}/xen/README*

# standard gnu info files
rm -rf %{buildroot}/usr/info

# adhere to Static Library Packaging Guidelines
rm -rf %{buildroot}/%{_libdir}/*.a

%if %build_efi
# clean up extra efi files
rm -rf %{buildroot}/%{_libdir}/efi
%endif

############ fixup files in /etc ############

# logrotate
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d/
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

# init scripts
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xen-watchdog
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xencommons
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xendomains
rm %{buildroot}%{_sysconfdir}/rc.d/init.d/xendriverdomain
rm %{buildroot}%{_sysconfdir}/sysconfig/xendomains

cp %{SOURCE32} %{buildroot}/usr/lib/modules-load.d/xen.conf

# Qubes specific - get rid of standard domain starting scripts
rm %{buildroot}%{_unitdir}/xen-qemu-dom0-disk-backend.service
rm %{buildroot}%{_unitdir}/xendomains.service

############ create dirs in /var ############

mkdir -p %{buildroot}%{_localstatedir}/lib/xen/images
mkdir -p %{buildroot}%{_localstatedir}/log/xen/console

ln -s ../sbin/xl %{buildroot}/%{_bindir}/xl

############ debug packaging: list files ############

find %{buildroot} -print | xargs ls -ld | sed -e 's|.*%{buildroot}||' > f2.list
diff -u f1.list f2.list || true

############ assemble license files ############

mkdir licensedir
# avoid licensedir to avoid recursion, also stubdom/ioemu and dist
# which are copies of files elsewhere
find . -path licensedir -prune -o -path stubdom/ioemu -prune -o \
  -path dist -prune -o -name COPYING -o -name LICENSE | while read file; do
  mkdir -p licensedir/`dirname $file`
  install -m 644 $file licensedir/$file
done

############ all done now ############

%post runtime
%systemd_post xenstored.service xenconsoled.service

%preun runtime
%systemd_preun xenstored.service xenconsoled.service

%postun runtime
%systemd_postun

%post qubes-vm
# Unconditionally enable this service in Qubes VM
systemctl enable xendriverdomain.service >/dev/null 2>&1 || :

%preun qubes-vm
%systemd_preun xendriverdomain.service

%postun qubes-vm
%systemd_postun

%post libs

/sbin/ldconfig

# reload libxl library
systemctl try-restart libvirtd.service >/dev/null 2>&1 || :

%postun libs -p /sbin/ldconfig

%if %build_hyp
%post hypervisor
%if %build_efi
EFI_DIR=$(efibootmgr -v 2>/dev/null | awk '
      /^BootCurrent:/ { current=$2; }
      /^Boot....\* / {
          if ("Boot" current "*" == $1) {
              sub(".*File\\(", "");
              sub("\\\\xen.efi\\).*", "");
              gsub("\\\\", "/");
              print;
          }
      }')
# FAT (on ESP) does not support symlinks
# override the file on purpose
if [ -d "/boot/efi${EFI_DIR}" ]; then
  cp -pf /boot/efi/EFI/qubes/xen-%{version}.efi /boot/efi${EFI_DIR}/xen.efi
else
  cp -pf /boot/efi/EFI/qubes/xen-%{version}.efi /boot/efi/EFI/qubes/xen.efi
fi
%endif

if [ -f /boot/efi/EFI/qubes/xen.cfg ]; then
    if ! grep -q smt=off /boot/efi/EFI/qubes/xen.cfg; then
        sed -i -e 's:^options=.*:\0 smt=off:' /boot/efi/EFI/qubes/xen.cfg
    fi
fi

if [ -f /etc/default/grub ]; then
    if ! grep -q smt=off /etc/default/grub; then
        echo 'GRUB_CMDLINE_XEN_DEFAULT="$GRUB_CMDLINE_XEN_DEFAULT smt=off"' >> /etc/default/grub
        grub2-mkconfig -o /boot/grub2/grub.cfg
    fi
fi

if [ $1 == 1 -a -f /sbin/grub2-mkconfig ]; then
  if [ -f /boot/grub2/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
  fi
  if [ -f /boot/efi/EFI/qubes/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/efi/EFI/qubes/grub.cfg
  fi
fi

%postun hypervisor
if [ -f /sbin/grub2-mkconfig ]; then
  if [ -f /boot/grub2/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
  fi
  if [ -f /boot/efi/EFI/qubes/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/efi/EFI/qubes/grub.cfg
  fi
fi
%endif

%if %build_ocaml
%post ocaml
%systemd_post oxenstored.service

%preun ocaml
%systemd_preun oxenstored.service

%postun ocaml
%systemd_postun
%endif

%clean
rm -rf %{buildroot}

# Base package only contains XenD/xm python stuff
#files -f xen-xm.lang
%files
%defattr(-,root,root)
%doc COPYING README
%{_bindir}/xencons

%files -n python2-%{name}
%{python2_sitearch}/%{name}
%{python2_sitearch}/xen-*.egg-info

%files -n python%{python3_pkgversion}-%{name}
%{python3_sitearch}/%{name}
%{python3_sitearch}/xen-*.egg-info

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/fs

# All runtime stuff except for XenD/xm python stuff
%files runtime
%defattr(-,root,root)

%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/
%config %attr(0700,root,root) %{_sysconfdir}/%{name}/scripts/*

%{_sysconfdir}/bash_completion.d/xl.sh
%exclude %{_unitdir}/xendriverdomain.service

%{_unitdir}/proc-xen.mount
%{_unitdir}/var-lib-xenstored.mount
%{_unitdir}/xen-init-dom0.service
%{_unitdir}/xenstored.service
%{_unitdir}/xenconsoled.service
%{_unitdir}/xen-watchdog.service
/usr/lib/modules-load.d/xen.conf

%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/xen/xl.conf
%config(noreplace) %{_sysconfdir}/xen/cpupool
%config(noreplace) %{_sysconfdir}/xen/xlexample*

# Rotate console log files
%config(noreplace) %{_sysconfdir}/logrotate.d/xen

# Programs run by other programs
%dir /usr/lib/%{name}
%dir /usr/lib/%{name}/bin
# List them explicitly to exclude files owned by xen-hvm package
%attr(0700,root,root) /usr/lib/%{name}/bin/convert-legacy-stream
%attr(0700,root,root) /usr/lib/%{name}/bin/ivshmem-client
%attr(0700,root,root) /usr/lib/%{name}/bin/ivshmem-server
%attr(0700,root,root) /usr/lib/%{name}/bin/libxl-save-helper
%attr(0700,root,root) /usr/lib/%{name}/bin/lsevtchn
%attr(0700,root,root) /usr/lib/%{name}/bin/pygrub
%attr(0700,root,root) /usr/lib/%{name}/bin/readnotes
%attr(0700,root,root) /usr/lib/%{name}/bin/verify-stream-v2
%attr(0700,root,root) /usr/lib/%{name}/bin/xen-init-dom0
%attr(0700,root,root) /usr/lib/%{name}/bin/xenconsole
%attr(0700,root,root) /usr/lib/%{name}/bin/xenctx
%attr(0700,root,root) /usr/lib/%{name}/bin/xendomains
%attr(0700,root,root) /usr/lib/%{name}/bin/xenpvnetboot
# QEMU runtime files
%dir %{_datadir}/%{name}/qemu
%dir %{_datadir}/%{name}/qemu/keymaps
%{_datadir}/%{name}/qemu/keymaps/*
%dir %{_datadir}/qemu-xen
%dir %{_datadir}/qemu-xen/qemu
%{_datadir}/qemu-xen/qemu/*

# man pages
%{_mandir}/man1/xentop.1*
%{_mandir}/man1/xentrace_format.1*
%{_mandir}/man8/xentrace.8*
%{_mandir}/man1/xl.1*
%{_mandir}/man5/xl.cfg.5*
%{_mandir}/man5/xl.conf.5*
%{_mandir}/man5/xlcpupool.cfg.5*
%{_mandir}/man1/xenstore*

%{python2_sitearch}/fsimage.so
%{python2_sitearch}/grub
%{python2_sitearch}/pygrub-*.egg-info

# The firmware
%ifarch %{ix86} x86_64
%dir /usr/lib/%{name}/boot
/usr/lib/xen/boot/xenstore-stubdom.gz
/usr/lib/xen/boot/pv-grub*.gz
/usr/lib/xen/boot/vtpm-stubdom.gz
/usr/lib/xen/boot/vtpmmgr-stubdom.gz
%endif
# General Xen state
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/%{name}/dump
%dir %{_localstatedir}/lib/%{name}/images
# Xenstore persistent state
%dir %{_localstatedir}/lib/xenstored
# Xenstore runtime state
%ghost %{_localstatedir}/run/xenstored

# All xenstore CLI tools
%{_bindir}/qemu-*-xen
%{_bindir}/xenstore
%{_bindir}/xenstore-*
%{_bindir}/pygrub
%{_bindir}/xentrace*
/usr/lib/%{name}/bin/init-xenstore-domain
#%%{_bindir}/remus
# blktap daemon
%{_sbindir}/tapdisk*
# XSM
%if %build_xsm
%{_sbindir}/flask-*
%endif
# Disk utils
%{_sbindir}/qcow-create
%{_sbindir}/qcow2raw
%{_sbindir}/img2qcow
# Misc stuff
%{_bindir}/xen-detect
%{_bindir}/xencov_split
%{_sbindir}/gdbsx
%{_sbindir}/kdd
%{_sbindir}/lock-util
%{_sbindir}/tap-ctl
%{_sbindir}/td-util
%{_sbindir}/vhd-*
%{_sbindir}/xen-bugtool
%{_sbindir}/xen-hptool
%{_sbindir}/xen-hvmcrash
%{_sbindir}/xen-hvmctx
%{_sbindir}/xen-tmem-list-parse
%{_sbindir}/xenconsoled
%{_sbindir}/xenlockprof
%{_sbindir}/xenmon.py*
%{_sbindir}/xentop
%{_sbindir}/xentrace_setmask
%{_sbindir}/xenbaked
%{_sbindir}/xenstored
%{_sbindir}/xenpm
%{_sbindir}/xenpmd
%{_sbindir}/xenperf
%{_sbindir}/xenwatchdogd
%{_sbindir}/xl
%{_sbindir}/xen-lowmemd
%{_sbindir}/xen-ringwatch
%{_sbindir}/xencov
%{_sbindir}/xen-mfndump
%{_sbindir}/xen-livepatch
%{_bindir}/xen-cpuid
/usr/share/pkgconfig/*
%{_bindir}/xenalyze
%{_sbindir}/xentrace
%{_sbindir}/xentrace_setsize
%{_bindir}/xl

# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen
# Guest/HV console logs
%dir %attr(0700,root,root) %{_localstatedir}/log/xen/console

%files hypervisor
%if %build_hyp
%defattr(-,root,root)
/boot/xen-*.gz
%config(noreplace) /boot/xen-*.config
%if %build_xsm
%dir %attr(0755,root,root) /boot/flask
/boot/flask/xenpolicy*
%endif
%if %build_efi
/boot/efi/EFI/qubes/*.efi
%endif
/usr/lib/debug/xen*
%endif

%files doc
%defattr(-,root,root)
%doc docs/misc/
%doc dist/install/usr/share/doc/xen/html

%files devel
%defattr(-,root,root)
%{_includedir}/*.h
%dir %{_includedir}/xen
%{_includedir}/xen/*
%dir %{_includedir}/xenstore-compat
%{_includedir}/xenstore-compat/*
%{_libdir}/*.so

%files licenses
%defattr(-,root,root)
%doc licensedir/*

%if %build_ocaml
%files ocaml
%defattr(-,root,root)
%{_libdir}/ocaml/xen*
%exclude %{_libdir}/ocaml/xen*/*.a
%exclude %{_libdir}/ocaml/xen*/*.cmxa
%exclude %{_libdir}/ocaml/xen*/*.cmx
%{_libdir}/ocaml/stublibs/*.so
%{_libdir}/ocaml/stublibs/*.so.owner
%{_sbindir}/oxenstored
%config(noreplace) %{_sysconfdir}/xen/oxenstored.conf
%{_unitdir}/oxenstored.service

%files ocaml-devel
%defattr(-,root,root)
%{_libdir}/ocaml/xen*/*.a
%{_libdir}/ocaml/xen*/*.cmxa
%{_libdir}/ocaml/xen*/*.cmx
%endif

%files hvm
# The firmware
%ifnarch ia64
/usr/lib/%{name}/bin/stubdom-dm
/usr/lib/%{name}/bin/qemu-dm
/usr/lib/%{name}/bin/qemu-img
/usr/lib/%{name}/bin/qemu-io
/usr/lib/%{name}/bin/qemu-nbd
/usr/lib/%{name}/bin/qemu-system-i386
/usr/lib/%{name}/bin/stubdompath.sh
/usr/lib/%{name}/bin/xenpaging
# HVM loader is always in /usr/lib regardless of multilib
/usr/lib/xen/boot/hvmloader
/usr/lib/xen/boot/ioemu-stubdom.gz
/usr/lib/xen/boot/ovmf.bin
%endif

%files qemu-tools
/usr/bin/qemu-img
/usr/bin/qemu-io
/usr/bin/qemu-nbd
/usr/share/locale/*/LC_MESSAGES/qemu.mo

%files qubes-vm
%{_bindir}/xenstore
%{_bindir}/xenstore-*
%{_sbindir}/xl
%{_unitdir}/xendriverdomain.service
%config(noreplace) %{_sysconfdir}/xen/xl.conf

%dir %attr(0700,root,root) %{_sysconfdir}/xen
%dir %attr(0700,root,root) %{_sysconfdir}/xen/scripts/
%config %attr(0700,root,root) %{_sysconfdir}/xen/scripts/*

# General Xen state
%dir %{_localstatedir}/lib/xen
%dir %{_localstatedir}/lib/xen/dump

# Xen logfiles
%dir %attr(0700,root,root) %{_localstatedir}/log/xen

# Python modules
%dir %{python2_sitearch}/xen
%{python2_sitearch}/xen/__init__.*
%{python2_sitearch}/xen/lowlevel
%{python2_sitearch}/xen-*.egg-info


%changelog
